use strict;
use warnings;

# this could have been written in a shell script, but I am more confortable in Perl

if ($#ARGV != 1)
{
    print "Usage: $0 <parameter_set> <parameter_description>\n";
    print "\t<parameter_description> will be used in the output dir\n";
    exit;    
}

my $params = $ARGV[0];
my $pdesc = $ARGV[1];
my $path = "../../HotKnotsCommon/data";

my @sets = ();
$sets[0] = "$path/TRA_HotKnots_max200_S80P"; 
$sets[1] = "$path/TES_pkshort_max200_RenJab-S20";
$sets[2] = "$path/TES_nopkshort_max200_RenJab-S20";
$sets[3] = "$path/TES_pklong_max200_RenJab-S20";
$sets[4] = "$path/TES_nopklong_max200_RenJab-S20";

my $sge_script = "sge_add_initial_predictions.sh";

foreach my $set (@sets)
{
    # get the number of files in $set
    my $num = 0;
    $num = `ls $set/file* | wc -l`;
    chomp ($num);
    exit unless $num >= 1;
    
    # compose the name of the output directory
    my $outdir = $set;
    # we want it to be in ../data
    $outdir =~ s/$path/\.\.\/data/;
    $outdir .= "$pdesc";
    
    `rm -rf $outdir; mkdir $outdir`;
    
    # now start an SGE job on the local cluster, assuming you can qsub from this machine
    my $command = "qsub -p -1 -t 1000-". (999+$num) ." $sge_script $params $set $outdir";
    print "$command\n";
    system ($command);
}

