use strict;

# given a directory, average the results on the 4 test sets
# also do the entire average

if ($#ARGV != 0)
{
    print "Usage $0 <hotknots_dir>\n";
    exit;
}

# assume there's only one set of directories "pred_par*"

my $hdir = $ARGV[0];
my $measure;
my $parid;
my $dir;
my $path = "";
my $result;
my $result_pkshort;
my $result_nopkshort;
my $result_pklong;
my $result_nopklong;
my $result_train;
my $result_test;
my $value;

if ($0 =~ /(\S+\/)/)
{
    $path = $1;
}
#print "$path\n";

# create a directory with all the test data
my $test_dir = "$hdir/pred_par_ALL_TEST";
system ("rm -rf $test_dir");
if (! -e $test_dir)
{
    system ("mkdir $test_dir");
    foreach $dir (glob ("$hdir/pred_par*TES*initial*"))	# added TES because now I can have TRA too
    {
        system ("cat $dir/out* >> $test_dir/out_S-Test.txt");
    }
}

# first get all the F-measures

$measure = "F-measure";

foreach $dir (glob ("$hdir/pred_par*"))
{
    #print "$dir\n";
    if ($dir =~ /pred_par(\d+)_/)
    {
        $parid = $1;
    }
    # Now get the averages
    system ("echo \"-----\nResults of params $parid on test set $dir\" >> $hdir/results_final.txt");
    #print "Executing...    perl ${path}collect_results.pl $dir\n";
    $result = `perl ${path}collect_results.pl $dir $measure`;
    system ("echo -n \"$result\" >> $hdir/results_final.txt");
    if ($result =~ /New $measure: (\S+)/)    {     $value = $1;    }    
    if      ($dir =~ /_pkshort/)      {   $result_pkshort = $value;   }
    elsif   ($dir =~ /_nopkshort/)    {   $result_nopkshort = $value; }
    elsif   ($dir =~ /_pklong/)       {   $result_pklong = $value;    }
    elsif   ($dir =~ /_nopklong/)     {   $result_nopklong = $value;  }
    elsif   ($dir =~ /$test_dir/)     {   $result_test = $value;    }    
}

#print "TRain: $result_train\n";
#print "Test: $result_test\n"; 


# now get sens and PPV for test
my $sens_test;
my $ppv_test;
$measure = "sens";
$result = `perl ${path}collect_results.pl $test_dir $measure`;
system ("echo -n \"$result\" >> $hdir/results_final.txt");
if ($result =~ /New $measure: (\S+)/)    {     $sens_test = $1;    }

$measure = "ppv";
$result = `perl ${path}collect_results.pl $test_dir $measure`;
system ("echo -n \"$result\" >> $hdir/results_final.txt");
if ($result =~ /New $measure: (\S+)/)    {     $ppv_test = $1;    }



# Now recompute it, don't get it from here any more
#Best F-measure on the TRAINING set: 0.764
# get the result on the training set
#$result = `cat $hdir/results_final.txt | grep "Best $measure on the TRAINING set"`;
#if ($result =~ /Best $measure on the TRAINING set: (\S+)/)
#{
#    $result_train = $1;
#}

# Now parse the $hdir directory name to get the algorithm parameters
my $bnd;
my $cg;
my $lambda;
my $mean;
my $eta;
my $fix;

if ($hdir =~ /bnd(\S+)K/)       {   $bnd = "B=$1";  }
if ($hdir =~ /MM1/)     {   $cg = "DIM-CG"; }
elsif ($hdir =~ /MM2/)  {   $cg = "LAM-CG"; }
else    {   $cg = "NOM-CG"; }
if ($hdir =~ /lambda(\d+)_/)     {   $lambda = "\$\\lambda = $1\$";   }
if ($hdir =~ /mean0/)         { $mean = "\$\\mu=0\$                 "; }
elsif ($hdir =~ /meaninit/)   { $mean = "\$\\mu=\\vct\\uptheta^{(0)}\$"; }
# in the CC directory, it's either meanCC or meanbestLAMCG
if ($hdir =~ /meanCC/)         { $mean = "\$\\mu=0\$                 "; }
elsif ($hdir =~ /meanCC/ || $hdir =~ /meanbestLAMCG/)   { $mean = "\$\\mu=\\vct\\uptheta^{(0)}\$"; }
if ($hdir =~ /eta([^_]+)_/)   {   $eta = "\$\\eta = $1\$";  }
if ($hdir =~ /(FIX-[^_]+)_/)  {   $fix = $1;  }


my $for_table;

$for_table = "$cg $fix\t $bnd, $lambda, $mean, $eta &";
$for_table .= sprintf ("%.3f & %.3f & %.3f & %.3f & %.3f & %.3f (%.3f, %.3f) \\\\", $result_train, $result_pkshort, $result_pklong, $result_nopkshort, $result_nopklong, $result_test, $sens_test, $ppv_test);
print "$for_table\n";
system ("echo -n \"$for_table\" >> $hdir/results_final.txt");



