#!/bin/sh

#echo $#

if [ $# -ne 2 ]; then
    echo "Usage: $0 <param_set> <output_dir>"
    exit
fi

#echo $1 

PREDICTOR=./predict_and_analyse_results_simfold
PARAMS=$1	#../data/turner_parameters_fm363_constrdangles.txt
DIR=$2

rm -rf $DIR
mkdir $DIR

echo "PREDICTOR=$PREDICTOR" > $DIR/results.txt
echo "PARAMS=$PARAMS" >> $DIR/results.txt

INPUTS=("TRA_HotKnots_max200_S80P_initialDP.txt" "TES_pkshort_max200_RenJab-S20_initialDP.txt" "TES_pklong_max200_RenJab-S20_initialDP.txt" "TES_nopkshort_max200_RenJab-S20_initialDP.txt"  "TES_nopklong_max200_RenJab-S20_initialDP.txt");

Inum=${#INPUTS[@]}
echo "$Inum directories:"

for ((i=0;i<$Inum;i++)); do
    echo "   ${INPUTS[${i}]}"
    $PREDICTOR $PARAMS ../data/${INPUTS[${i}]} $DIR/prediction$i.txt $DIR/accuracy$i.txt
    perl average_analysed_results.pl $DIR/accuracy$i.txt >> $DIR/results.txt
done

# print to the results file
F0=`perl average_analysed_results.pl $DIR/accuracy0.txt | grep Newpar | awk '{print $12}'`
F1=`perl average_analysed_results.pl $DIR/accuracy1.txt | grep Newpar | awk '{print $12}'`
F2=`perl average_analysed_results.pl $DIR/accuracy2.txt | grep Newpar | awk '{print $12}'`
F3=`perl average_analysed_results.pl $DIR/accuracy3.txt | grep Newpar | awk '{print $12}'`
F4=`perl average_analysed_results.pl $DIR/accuracy4.txt | grep Newpar | awk '{print $12}'`

# now put all the test sets together
cat $DIR/accuracy1.txt $DIR/accuracy2.txt $DIR/accuracy3.txt $DIR/accuracy4.txt > $DIR/accuracy_TES.txt
perl average_analysed_results.pl $DIR/accuracy_TES.txt >> $DIR/results.txt
F_TES=`perl average_analysed_results.pl $DIR/accuracy_TES.txt | grep Newpar | awk '{print $12 " (" $4 ", "$8 ")"}'`


echo "SUMMARY:" >> $DIR/results.txt
echo "$F0 & $F1 & $F2 & $F3 & $F4 & $F_TES" >> $DIR/results.txt


