use strict;

# given a directory, run prediction on the 4 test sets
# right, this should have been just a shell script


if ($#ARGV != 2)
{
    print "Usage $0 <cluster> <hotknots_dir> <iteration_of_best_params:10|20>\n";
    exit;
}

my $cluster = $ARGV[0];
my $hdir = $ARGV[1];
my $parid = $ARGV[2];


my $pkshort = "TES_pkshort_max200_RenJab-S20_initialDP";
my $nopkshort = "TES_nopkshort_max200_RenJab-S20_initialDP";
my $pklong = "TES_pklong_max200_RenJab-S20_initialDP";
my $nopklong = "TES_nopklong_max200_RenJab-S20_initialDP";

my $line;
# Now modify $hdir/test_results.sh so that I have one more parameter
open (FILE, ">$hdir/test_results.sh") || die ("Cannot open file $hdir/test_results.sh");
print FILE "#!/bin/sh\n\n";
print FILE "#\$ -m n\n";
print FILE "#\$ -cwd\n";
print FILE "#\$ -S /bin/sh\n";
print FILE "#\$ -o /dev/null\n";
print FILE "#\$ -e /dev/null\n";
print FILE "\n# first argument $1 is the new parameter set\n";
print FILE "# second argument $2 is the old directory\n";
print FILE "# third argument $3 is the new directory\n";
print FILE "\n../../tools/test_hotknotsDP \$1  \$2/file\${SGE_TASK_ID}.txt \$3/out\${SGE_TASK_ID}.txt >> \$4\n\n\n";
close (FILE);

system ("mkdir $hdir/pred_par${parid}_$pkshort");
system ("mkdir $hdir/pred_par${parid}_$nopkshort");
system ("mkdir $hdir/pred_par${parid}_$pklong");
system ("mkdir $hdir/pred_par${parid}_$nopklong");

my $last_pkshort = `ls ../data/$pkshort/file* | wc -l`;
chomp ($last_pkshort);
$last_pkshort += 999;
my $last_nopkshort = `ls ../data/$nopkshort/file* | wc -l`;
chomp ($last_nopkshort);
$last_nopkshort += 999;
my $last_pklong = `ls ../data/$pklong/file* | wc -l`;
chomp ($last_pklong);
$last_pklong += 999;
my $last_nopklong = `ls ../data/$nopklong/file* | wc -l`;
chomp ($last_nopklong);
$last_nopklong += 999;

my @commands = ();
my $command;

$commands[0] = "-t 1000-${last_pkshort} test_results.sh params_sub-${parid}.txt ../../data/$pkshort pred_par${parid}_$pkshort results_pkshort.txt";
$commands[1] = "-t 1000-${last_nopkshort} test_results.sh params_sub-${parid}.txt ../../data/$nopkshort pred_par${parid}_$nopkshort results_nopkshort.txt";
$commands[2] = "-t 1000-${last_pklong} test_results.sh params_sub-${parid}.txt ../../data/$pklong pred_par${parid}_$pklong results_pklong.txt";
$commands[3] = "-t 1000-${last_nopklong} test_results.sh params_sub-${parid}.txt ../../data/$nopklong pred_par${parid}_$nopklong results_nopklong.txt";

foreach $command (@commands)
{
    if ($cluster eq "icics")
    {   system("cd $hdir; qsub $command");     }
    else
    {   system("nohup ssh samos \"cd bio/Sandbox/Projects/EnergyCG_other_predictors/HotKnotsDP/tools; cd $hdir; qsub -P kpm $command\""); }
}

#


# When these are done, just run average_test_results
